using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EasyBuildSQL;


namespace webSample1
{
    public partial class frmExecSP : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {

                //Create ebQuery to civil_state
                ebQuery qCivilState = new ebQuery(Global.Credentials);
                //Add SQL Sentence
                qCivilState.AddSQL("SELECT * FROM civil_state");

                //Create dataset
                var qCivilStateDS = qCivilState.OpenDataSet();

                //Fill the DropDownList
				cboCivilState.DataSource = qCivilStateDS.Tables[0];
                cboCivilState.DataTextField = "state_descrip";
                cboCivilState.DataValueField = "civilstateID";
                cboCivilState.DataBind();
                cboCivilState.SelectedValue = "1";
            }
        }


        protected void btnExecSP_Click(object sender, EventArgs e)
        {
            ebStoredProc SP = new ebStoredProc("NewPerson", Global.Credentials);
            SP.AddParameter("FIRSTNAME", System.Data.DbType.String).Value = txtFirstName.Text;
            SP.AddParameter("LASTNAME", System.Data.DbType.String).Value = txtLastName.Text;
            SP.AddParameter("BIRTHDATE", System.Data.DbType.Date).Value = Calendar1.SelectedDate;
            SP.AddParameter("CIVILSTATE", System.Data.DbType.Int16).Value = cboCivilState.SelectedValue;
            //Parameter OUTPUT
            SP.AddParameter("NEWID", System.Data.DbType.Int32, System.Data.ParameterDirection.Output);

            if (!SP.Execute())
            {
                //If error show the error message
                txtResult.Text = SP.ErrorSQL;
                GridView1.DataSource = null;
                GridView1.DataBind();
            }
            else
            {
                //If inserted show the new code assigned
                txtResult.Text = "New record inserted, PersonID = " +  ebField.AsInteger(SP.Parameter("NEWID").Value).ToString();
                ebQuery qPerson = new ebQuery(Global.Credentials);
                if (Global.Credentials.ObtainDBType() == DataBaseType.MSSQL)
                    qPerson.AddSQL("SELECT TOP 5 personID, lastname, firstname, birthdate, civilstateID FROM person order by personID desc");
                else
                    qPerson.AddSQL("SELECT personID, lastname, firstname, birthdate, civilstateID FROM person order by personID desc LIMIT 5");

                var qDS = qPerson.OpenDataSet();
                if (qDS != null)
                {
                    GridView1.DataSource = qDS.Tables[0];
                    GridView1.DataBind();
                }
                else
                {
                    txtResult.Text = qPerson.ErrorSQL;
                    GridView1.DataSource = null;
                    GridView1.DataBind();

                }


            }

        }
    }
}
