﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EasyBuildSQL;

namespace webSample1
{
    public partial class frmReadRecordFromSP : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {

                //Create ebQuery to Country
                ebQuery qCountry = new ebQuery(Global.Credentials);
                //Add SQL Sentence
                qCountry.AddSQL("SELECT * FROM country");

                //Create dataset
                var qCountryDS = qCountry.OpenDataSet();

                //Assign the DataSource to the control and fill the DropDownList
                cboCountry.DataSource = qCountryDS.Tables[0];
                cboCountry.DataTextField = "country_name";
                cboCountry.DataValueField = "countryID";
                cboCountry.DataBind();
                cboCountry.SelectedValue = "1";

                //Create ebQuery to AddressType
                ebQuery qAddressType = new ebQuery(Global.Credentials);
                //Add SQL Sentence
                qAddressType.AddSQL("SELECT * FROM address_type");

                //Create dataset
                var qAddressTypeDS = qAddressType.OpenDataSet();

                //Assign the DataSource to the control and fill the DropDownList
                cboAddressType.DataSource = qAddressTypeDS.Tables[0];
                cboAddressType.DataTextField = "type_descrip";
                cboAddressType.DataValueField = "addresstypeID";
                cboAddressType.DataBind();
                cboAddressType.SelectedValue = "1";

                //Create ebQuery to CivilState
                ebQuery qCivilState = new ebQuery(Global.Credentials);
                //Add SQL Sentence
                qCivilState.AddSQL("SELECT * FROM civil_state");

                //Create dataset
                var qCivilStateDS = qCivilState.OpenDataSet();

                //Assign the DataSource to the control and fill the DropDownList
                cboCivilState.DataSource = qCivilStateDS.Tables[0];
                cboCivilState.DataTextField = "state_descrip";
                cboCivilState.DataValueField = "civilstateID";
                cboCivilState.DataBind();
                cboCivilState.SelectedValue = "1";
            }

        }

        protected void btnExecSP_Click(object sender, EventArgs e)
        {
            ebStoredProc SP = new ebStoredProc("PersonsByCountry", Global.Credentials);
            SP.AddParameter("COUNTRYID", System.Data.DbType.Int32).Value = cboCountry.SelectedValue;
            SP.AddParameter("ADDRESTYPE", System.Data.DbType.Int16).Value = cboAddressType.SelectedValue;

            //Empty the textbox 
            txtFirstName.Text = string.Empty;
            txtLastName.Text = string.Empty;

            //Open a dataReader
            var spDR = SP.OpenDataReader();

            int Cant = 0;

            //If DataReader is null then show the error
            if (spDR == null)
            {
                //Show the error
                txtResult.Text = SP.ErrorSQL;
            }
            //If SPDs is not null then ask if has record
            else if (spDR.HasRows) 
            {
                try
                {
                    //iterate the DataReader
                    while (spDR.Read())
                    {
                        ++ Cant ;
               
                        if (ebField.AsInteger(spDR["civilstateID"]).ToString() == cboCivilState.SelectedValue)
                        {
                            //Put in the textbox the LastName and FirstName values
                            txtLastName.Text = ebField.AsString(spDR["lastname"]);
                            txtFirstName.Text = ebField.AsString(spDR["firstname"]);

                            //Show in the result textbox the record number
                            txtResult.Text = "The first person encountered was in the record: " + Cant.ToString();
                            break;
                        }

                    }
                }
                finally
                {
                    //Close de DataReader
                    spDR.Close();
                }

            }

        }
    }
}
