﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EasyBuildSQL;
using System.IO;

namespace webSample1
{
    public partial class frmSPWithParamBLOB : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {

                //Create ebQuery to Country
                ebQuery qPerson = new ebQuery(Global.Credentials);
                //Add SQL Sentence
                switch (Global.Credentials.ObtainDBType())
                {
                    case DataBaseType.MSSQL:
                        {
                            qPerson.AddSQL("SELECT personID, lastname + ' ' + firstname AS Name FROM Person");
                            break;
                        }
                    default:
                        {
                            qPerson.AddSQL("SELECT personID, concat(lastname , ' ' , firstname) AS Name FROM Person ");
                            break;
                        }
                }
                qPerson.AddSQL("order by lastname, firstname;");

                //Create dataset
                var qPersonDS = qPerson.OpenDataSet();

                cboPerson.DataSource = qPersonDS.Tables[0];
                cboPerson.DataTextField = "name";
                cboPerson.DataValueField = "PersonID";
                cboPerson.DataBind();
                cboPerson.SelectedValue = "1";

            }
        }


        protected void cboPerson_SelectedIndexChanged(object sender, EventArgs e)
        {
        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            //Create ebQuery to Country
            ebQuery qPhoto = new ebQuery(Global.Credentials);
            //Create query sentence with parameter
            qPhoto.AddSQL("select photo from person where personID = @ID");
            //Create a perameter
            qPhoto.AddParameter("ID", System.Data.DbType.Int32, int.Parse(cboPerson.SelectedValue));

            //Open datareader
            var drPhoto = qPhoto.OpenDataReader();
            if ((drPhoto != null) && (drPhoto.HasRows) && (drPhoto.Read()))
            {
                //Save the BLOB Field to File
                if (ebBLOBField.SaveToFile(drPhoto[0], base.MapPath("."), "photo.jpg"))
                    //Assign the new image 
                    Image1.ImageUrl = "photo.jpg";
                else
                    Image1.ImageUrl = string.Empty;

            }


        }

        protected void btnInsertImage_Click(object sender, EventArgs e)
        {

            if (FileUpload1.FileName == string.Empty)
            {
                txtResult.Text = "No file selected";
                return;
            }

            //Define the photo file name
            string PhotoUpload = Path.Combine(base.MapPath("."), "photoUpload.jpg");
            
            //If file exists then delete
            if (File.Exists(PhotoUpload))
                File.Delete(PhotoUpload);

             FileUpload1.SaveAs(PhotoUpload);

            ebStoredProc SP = new ebStoredProc("UpdatePhoto", Global.Credentials);
            SP.AddParameter("PERSONID", System.Data.DbType.Int32).Value = int.Parse(cboPerson.SelectedValue);
            //Add BLOB Param
            SP.AddParameterBLOB("PHOTO", PhotoUpload);

            if (!SP.Execute())
            {
                //If error show the error message
                txtResult.Text = SP.ErrorSQL;

                //Clean the image
                Image1.ImageUrl = string.Empty;
            }
            else
            {
                //show the message
                txtResult.Text = "Photo Updated";

                //show the photo
                Button1_Click(sender, e);
            }

        }


    }
}
