#region license

/*
EasyBuildSQL - is a C# library oriented to help to developers to build sql sentence in differents database engine. 
EasyBuildSQL is developed to .NET Framework.
 
Copyright (C) 2010 - Alejandro Genovesi
http://sourceforge.net/projects/easybuildsql/ 
Contributor : Arturo Martinez

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public
 License as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.

 You should have received a copy of the GNU Library General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA 
 
*/

#endregion

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace EasyBuildSQL
{
  public class ebINSERT : ebDataModify
  {
    DataINSERT fInsert;

    public ebINSERT(string Table, string UserName, string Password, string DBName, string Server, DataBaseType DBType)
        : base(Table, UserName, Password, DBName, Server, DBType)
    {
      fInsert = new DataINSERT(fCommand, DBType, Table);

      fSentencia = fInsert;

      Initialize();
    }

    public ebINSERT(string Table, ConnectionCredentials Credentials)
        : base(Table,Credentials)
    {
        fInsert = new DataINSERT(fCommand, Credentials.ObtainDBType(), Table);

        fSentencia = fInsert;

        Initialize();
    }

    private int fIdentity = 0;
    public int Identity
    {
      get
      {
        return fIdentity;
      }
    }

    public bool ReturnIDENTITY
    {
      get
      {
        return fInsert.ReturnIDENTITY;
      }
      set
      {
        fInsert.ReturnIDENTITY = value;
      }
    }

    protected override void Initialize()
    {
      base.Initialize();

      fInsert.Initiate();
    }

    public override bool Execute()
    {
      try
      {
        fInsert.Finish();
        fCommand.CommandText = fInsert.SentenceSQL;

        fConnection.Open();

        fCommand.Connection = fConnection.Connection;

        if (fInsert.ReturnIDENTITY)
          fIdentity = Convert.ToInt32(fCommand.ExecuteScalar());
        else
          fCommand.ExecuteNonQuery();

        fConnection.Close();

        return true;
      }
      catch (Exception e)
      {
        fConnection.Close();
        fErrorSQL = e.Message;

        return false;
      }
    }
  } 
}
